/*
 * CollMap.java
 *
 * Created on April 15, 2003, 4:32 PM
 */

package dbmapper;

import java.io.Serializable;
/** This class maintains the vitals for a collection mapping.
 * For a collection map, a specific attribute will reference
 * a certain class and attribute which is in another class
 * than the one being mapped. Thus this class
 * maintains the specifics fo that other class-attribute
 *
 * @author Larry
 */
public class CollMap implements Serializable {
    
    /** The classname of the remote class
     */    
    private String className;
    
    /** the name of the remote attribute
     */    
    private String fkTome;
    
    /** If this map is valid
     */    
    private boolean valid=false;
    
    /** Creates a new instance of ManyMap */
    public CollMap() {
    }
    
    /** Get the name of the class this map refers to
     * @return the name of the class
     */    
    public String getClassname(){ return className; }
    /** Set the remote classname this map refers to
     * @param c The class name
     */    
    public void setClassname(String c){ className=c; }
    
    /** Get the remote attribute name of this map
     * @return The attribute name
     */    
    public String getFktome(){ return fkTome; }
    /** Set the remote attribute name of this map
     * @param f attribute name
     */    
    public void setFktome(String f){ fkTome=f; }
    
    /** t/f if this map is valid
     * @return validity
     */    
    public boolean isValid(){return valid; }
    /** set this map to be valid
     */    
    public void setValid(){ valid=true; }
    /** set the validity of this map to the passed in flag
     * @param flag t/f flag
     */    
    public void setValid(boolean flag){ valid=flag; }
    

}
