/*
 * CollMappSelector.java
 *
 * Created on April 15, 2003, 6:38 PM
 */

package dbmapper;

import javax.swing.DefaultListModel;
/** Form to allow user to select a collection mapping by choosing a
 * class and attribute to map as the FK to use for the collection.
 * @author Larry
 */
public class CollMappSelector extends javax.swing.JDialog {
    
    /** Creates new form CollMappSelector
     * @param parent the parent frame
     * @param modal t/f if dialog is modal
     */
    public CollMappSelector(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        classTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        attTextField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jPanel63 = new javax.swing.JPanel();
        tabtit3 = new javax.swing.JLabel();
        jScrollPane13 = new javax.swing.JScrollPane();
        classList = new javax.swing.JList();
        jPanel3 = new javax.swing.JPanel();
        jPanel31 = new javax.swing.JPanel();
        fkmeTit = new javax.swing.JLabel();
        fkmeChooser = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        okButt = new javax.swing.JButton();
        cancButt = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Collection  Selector");
        getContentPane().add(jLabel1);

        jLabel2.setText("Class");
        jPanel7.add(jLabel2);

        classTextField.setText("                                                                    ");
        jPanel7.add(classTextField);

        jLabel3.setText("Attribute");
        jPanel7.add(jLabel3);

        attTextField.setText("                ");
        jPanel7.add(attTextField);

        getContentPane().add(jPanel7);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        jPanel2.add(jPanel63);

        tabtit3.setText("Class List");
        jPanel2.add(tabtit3);

        classList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                classListMouseClicked(evt);
            }
        });

        jScrollPane13.setViewportView(classList);

        jPanel2.add(jScrollPane13);

        getContentPane().add(jPanel2);

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.Y_AXIS));

        fkmeTit.setText("Inverse Foeign-Key Attr:");
        jPanel31.add(fkmeTit);

        fkmeChooser.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "select-inverse-foreign key" }));
        fkmeChooser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fkmeChooserActionPerformed(evt);
            }
        });

        jPanel31.add(fkmeChooser);

        jPanel3.add(jPanel31);

        jPanel3.add(jPanel4);

        okButt.setText("Ok");
        okButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtActionPerformed(evt);
            }
        });

        jPanel5.add(okButt);

        cancButt.setText("Cancel");
        cancButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancButtActionPerformed(evt);
            }
        });

        jPanel5.add(cancButt);

        jPanel3.add(jPanel5);

        getContentPane().add(jPanel3);

        pack();
    }//GEN-END:initComponents

    /** When the user selects an item in the list of classes, this
     * class will update the pulldown selector with the list of attributes in
     * the class selected.
     * @param evt The event
     */    
    private void classListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_classListMouseClicked
        // Add your handling code here:
        // Add your handling code here:
        if ( classList.isSelectionEmpty() ) return;
        String[] attr=myProc.getClassAttList((String)classList.getSelectedValue());
        String[] newattrs=new String[attr.length+1];
        newattrs[0]="select-inverse-foreign-key-here";
        System.arraycopy(attr,0,newattrs,1,attr.length);
        fkmeChooser.setModel(new javax.swing.DefaultComboBoxModel(newattrs));
    }//GEN-LAST:event_classListMouseClicked

    /**
     * @param evt The event
     */    
    private void fkmeChooserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fkmeChooserActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_fkmeChooserActionPerformed

    /** When the user presses the "cancel" button, we invalidate the
     * CollMap and exit this form.
     * @param evt The event
     */    
    private void cancButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancButtActionPerformed
        // Add your handling code here:
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancButtActionPerformed

    /** When the user presses the "ok" button, we save the currently selected
     * class and attribute into the CollMap and hide this window.
     * @param evt The event
     */    
    private void okButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtActionPerformed
        // Add your handling code here:
        // Add your handling code here:
        if ( classList.isSelectionEmpty() ) {
            myMap.setValid(false);
            setVisible(false);
            dispose();
        }
        myMap.setClassname((String)classList.getSelectedValue());
        String meKey=(String)fkmeChooser.getSelectedItem();
        if ( meKey == null || meKey.equals("") ||  meKey.startsWith("select-") ){
                 myMap.setValid(false);
                 setVisible(false);
                 dispose();
        }
        myMap.setFktome(meKey);
        myMap.setValid(true);
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtActionPerformed
    
    /** Closes the dialog
     * @param evt The event
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    /** Set the base classname to work with.
     * @param classnam The classname
     */    
    public void setClassname(String classnam){ 
        myClassname=classnam; 
        classTextField.setText(myClassname);
    }
    /** Set the base attribute to work with
     * @param att The attribute
     */    
    public void setAttr(String att){  
        myAttr=att; 
        attTextField.setText(myAttr); 
        pack();
    }
    /** Set the list of classes in the model
     * @param classes list of classes
     */    
    public void setClassList(String[] classes){
        myClasses=classes;
        myClassListModel=new DefaultListModel();
        for (int i=0; i<classes.length; i++){
            myClassListModel.addElement(classes[i]);
        }
        classList.setModel(myClassListModel);
        classList.repaint();
    }
     
    /** Set the CollMap object to save results to
     * @param map The result object
     */    
    public void setResults(CollMap map){
        myMap = map;
    }

    /** Set the processor to use
     * @param proc The processor
     */    
    public void setProcessor(SourceProcessor proc){
        myProc=proc;
    }
    
    /** The processor this class uses for getting class/attribute info
     */    
    private SourceProcessor myProc=null;
    /** List model
     */    
    private DefaultListModel myClassListModel=null;
    /** The base classname this class is mapping
     */    
    private String myClassname=null;
    /** The base attribute this class is mapping
     */    
    private String myAttr=null;
    /** The list of classes we are working with
     */    
    private String[] myClasses=null;
    /** The Collection map this class will create/use.
     */    
    private CollMap myMap = null;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox fkmeChooser;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane13;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JButton cancButt;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel fkmeTit;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel63;
    private javax.swing.JTextField attTextField;
    private javax.swing.JButton okButt;
    private javax.swing.JTextField classTextField;
    private javax.swing.JList classList;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JLabel tabtit3;
    // End of variables declaration//GEN-END:variables
    
}
