/*
 * DbMapper.java
 *
 * Created on April 10, 2003, 5:59 PM
 */

package dbmapper;

import java.lang.*;
import java.awt.Frame;

/** The "main" application class for the dbmapper program. This is a simple class
 * that performs conifguration determination and loading then starts the main
 * mapping form window.(dbmapper.MapAssocs)<p>
 * @author Larry
 */
public class DbMapper {
    /** The configuration parameters
     */    
    Config conf=null;
    /**
     * Creates a new instance of DbMapper 
     */
    public DbMapper() {
    }
    
    /** 
     * The main program startup method.
     *
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new DbMapper().go();
    }
    
    /**
     * method to start up the application. Load the properties file if found, \
     * otherwise show the configuration window to get the config values.
     * Start a new SourceProcessor, then open the main mapping window.
     */    
    public void go(){
        if ( ! Utils.loadProperties("dbmapperp.properties") ){
            System.out.println("Properties load failed - please configure");
            // grab properties, if null
            DbMapperConfig configForm=new DbMapperConfig(new Frame(), true);
            configForm.show();
            while (configForm.isVisible() ){
                try{
                    Thread.sleep(300);
                }catch (InterruptedException ie){}
            }
            conf=configForm.getConfig();
            configForm.dispose();
        }else{
            conf=new Config();
            conf.setFromProperties();
        }
        
        SourceProcessor processor=new SourceProcessor();
        if ( conf.getAlwaysLoad() ){
            try {
                processor.load(conf);
            }catch (ConfigException ce){
                System.out.println("Sorry, I couldn't load the properties configuration " + ce);
                System.exit(1);
            }
        }
        
        MapAssocs mapper=new MapAssocs();
        mapper.setProcessor(processor);
        mapper.show();
    }
    
}


 