/*
 * DbMapperConfig.java
 *
 * Created on April 10, 2003, 12:31 PM
 */

package dbmapper;

import java.io.File;
import javax.swing.JFileChooser;
import java.awt.Frame;


/** This class is a JDialog for getting configuration
 * settings information.
 * @author Larry
 */
public class DbMapperConfig extends javax.swing.JDialog {
    
    /** The configuration object
     */    
    Config myConfig=null;
    /** frame
     */    
    Frame myParentFrame=null;
    
    /** Get the configuration object containing the settings
     * entered on this form
     * @return the configuration object
     */    
    public Config getConfig(){
        return myConfig;
    }
    
    /** Creates new form DbMapperConfig
     * @param parent parent window frame
     * @param modal t/f modal flag
     */
    public DbMapperConfig(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        myParentFrame=parent;
        initComponents();
        loadFromProps();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        titLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        dbTitLab = new javax.swing.JLabel();
        drivLab = new javax.swing.JLabel();
        urlLab = new javax.swing.JLabel();
        uidLab = new javax.swing.JLabel();
        passLab = new javax.swing.JLabel();
        schemaLab = new javax.swing.JLabel();
        driverField = new javax.swing.JTextField();
        dburlField = new javax.swing.JTextField();
        useridField = new javax.swing.JTextField();
        passwordField = new javax.swing.JTextField();
        schemaField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        scTitLab = new javax.swing.JLabel();
        sourceField = new javax.swing.JTextField();
        browseButt = new javax.swing.JButton();
        filtLab = new javax.swing.JLabel();
        filtField = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        quitButton = new javax.swing.JButton();
        writePropButt = new javax.swing.JButton();
        alwaysLoadCheck = new javax.swing.JCheckBox();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setTitle("DbMapper");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        titLabel.setFont(new java.awt.Font("Freestyle Script", 1, 36));
        titLabel.setText("DbMapper Configuration");
        getContentPane().add(titLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 10, -1, -1));

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        dbTitLab.setText("Database Definition");
        jPanel1.add(dbTitLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        drivLab.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        drivLab.setText("JDBC Driver:");
        jPanel1.add(drivLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, 100, -1));

        urlLab.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        urlLab.setText("DB URL:");
        jPanel1.add(urlLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, 100, -1));

        uidLab.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        uidLab.setText("Userid:");
        jPanel1.add(uidLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 80, 100, -1));

        passLab.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        passLab.setText("Password:");
        jPanel1.add(passLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 100, 100, -1));

        schemaLab.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        schemaLab.setText("Schema:");
        jPanel1.add(schemaLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 120, 100, -1));

        driverField.setText("jdbc-driver-class-name");
        jPanel1.add(driverField, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 40, 220, -1));

        dburlField.setText("db-access-url");
        jPanel1.add(dburlField, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 60, 220, -1));

        useridField.setText("username");
        jPanel1.add(useridField, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 80, 220, -1));

        passwordField.setText(" ");
        jPanel1.add(passwordField, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 100, 220, -1));

        schemaField.setText("schema name");
        jPanel1.add(schemaField, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 120, 220, -1));

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 60, 350, 150));

        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel2.setBorder(new javax.swing.border.EtchedBorder());
        scTitLab.setText("Sourcecode Definition");
        jPanel2.add(scTitLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));

        sourceField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sourceFieldActionPerformed(evt);
            }
        });

        jPanel2.add(sourceField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 230, -1));

        browseButt.setText("Browse...");
        browseButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtActionPerformed(evt);
            }
        });

        jPanel2.add(browseButt, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 30, -1, -1));

        filtLab.setText("Filter:");
        jPanel2.add(filtLab, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 60, -1, -1));

        jPanel2.add(filtField, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 60, 180, -1));

        getContentPane().add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 220, 350, 90));

        okButton.setText("Ok Let's Map!");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        getContentPane().add(okButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 350, -1, -1));

        quitButton.setText("GoAway");
        quitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitButtonActionPerformed(evt);
            }
        });

        getContentPane().add(quitButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(290, 390, -1, -1));

        writePropButt.setText("write Properties File...");
        writePropButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                writePropButtActionPerformed(evt);
            }
        });

        getContentPane().add(writePropButt, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 390, -1, -1));

        alwaysLoadCheck.setText("Always Load Fresh on startup");
        getContentPane().add(alwaysLoadCheck, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 320, -1, -1));

        pack();
    }//GEN-END:initComponents

    /** write the configuration out to a properties file
     * @param evt event
     */    
    private void writePropButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_writePropButtActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser(Utils.lastDir);
        chooser.setDialogTitle("Select file to save properties into:");
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("properties");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
           System.out.println("You chose to write this file as a properties file: " +
            chooser.getSelectedFile().getName());
           File dir=chooser.getCurrentDirectory();
           String fileName=chooser.getSelectedFile().getName();
           Config propConfig;
           try {
                propConfig=this.loadConfig();
           } catch ( ConfigException ce){
                ErrorPopup ep=new ErrorPopup(myParentFrame, true);  
                ep.popup(ce.toString());
                return;
           }
           try {
               propConfig.saveAsProperties(fileName);
           }catch (Exception e){
               ErrorPopup ep=new ErrorPopup(myParentFrame, true);
               ep.popup("error writing config properties file: " + e.toString());
               return;
           }
        }
        return;
    }//GEN-LAST:event_writePropButtActionPerformed

    /** Open a file browser to get the location of the class jar file
     * @param evt event
     */    
    private void sourceFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sourceFieldActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_sourceFieldActionPerformed

    /** Open a file browser to get the location of the class jar file
     * @param evt event
     */    
    private void browseButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser(Utils.lastDir);
        chooser.setDialogTitle("Select jar file of code:");
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("jar");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
           System.out.println("You chose to open this file: " +
            chooser.getSelectedFile().getName());
           File dir=chooser.getCurrentDirectory();
           Utils.lastDir=chooser.getCurrentDirectory(); // save for next time
           String fileName=chooser.getSelectedFile().getName();
           sourceField.setText(dir.getPath()+File.separator+fileName);
        }
 
    }//GEN-LAST:event_browseButtActionPerformed

    /** close up shop and go bye bye, invalidate config object
     * @param evt event
     */    
    private void quitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButtonActionPerformed
        // Add your handling code here:
        myConfig=null;
        setVisible(false);
        dispose();
    }//GEN-LAST:event_quitButtonActionPerformed

    /** save the configuration and hide this window
     * @param evt event
     */    
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        try {
           myConfig=this.loadConfig();
        } catch ( ConfigException ce){
            ErrorPopup ep=new ErrorPopup(myParentFrame, true);  
            ep.popup(ce.toString());
            return;
        }
        setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed
    
    /** Exit the Application
     * @param evt event
     */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitForm
    

    /** get the values from the window texxtfields and load
     * them into a configuration object
     * @throws ConfigException problem
     * @return the configuration object
     */
    public Config loadConfig()throws ConfigException {
        Config config=new Config();
        StringBuffer error=new StringBuffer();
        
        if ( driverField.getText().equals("") ){
               error.append("JDBC driver not specified");
        }
        config.setJdbcDriver(driverField.getText());
        
        if ( dburlField.getText().equals("") ){
               error.append(error.length()==0?"":"\n");
               error.append("DB URL not specified");
        }        
        config.setUrl(dburlField.getText());
        
        if ( useridField.getText().equals("") ){
               error.append(error.length()==0?"":"\n");
               error.append("Userid not specified");
        }                
        config.setUserid(useridField.getText());
        
        if ( passwordField.getText().equals("") ){
               error.append(error.length()==0?"":"\n");
               error.append("Password not specified");
        }                
        config.setPassword(passwordField.getText());
        
        if ( schemaField.getText().equals("") ){
               error.append(error.length()==0?"":"\n");
               error.append("Schema not specified");
        }   
        config.setSchema(schemaField.getText());
        
        if ( sourceField.getText().equals("") ){
               error.append(error.length()==0?"":"\n");
               error.append("Sourcecode location not specified");
        }            
        config.setJar(sourceField.getText());        
        config.setJarFilter(filtField.getText());
        
        config.setAlwaysLoad(alwaysLoadCheck.isSelected());
        
        if ( error.length() > 0 ){
            throw new ConfigException(error.toString());
        }
        return config;
    }
    
    /** load the configuration object from the current properties
     * settings.
     */    
    private void loadFromProps(){
        Config conf=new Config();
        conf.setFromProperties();
        driverField.setText(conf.getJdbcDriver());
        dburlField.setText(conf.getUrl());
        useridField.setText(conf.getUserid());
        passwordField.setText(conf.getPassword());
        schemaField.setText(conf.getSchema());
        sourceField.setText(conf.getJar());        
        filtField.setText(conf.getJarFilter());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox alwaysLoadCheck;
    private javax.swing.JLabel scTitLab;
    private javax.swing.JButton browseButt;
    private javax.swing.JButton writePropButt;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField passwordField;
    private javax.swing.JLabel uidLab;
    private javax.swing.JLabel filtLab;
    private javax.swing.JButton okButton;
    private javax.swing.JTextField filtField;
    private javax.swing.JLabel drivLab;
    private javax.swing.JTextField sourceField;
    private javax.swing.JButton quitButton;
    private javax.swing.JTextField driverField;
    private javax.swing.JLabel titLabel;
    private javax.swing.JLabel dbTitLab;
    private javax.swing.JTextField dburlField;
    private javax.swing.JTextField schemaField;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel passLab;
    private javax.swing.JLabel schemaLab;
    private javax.swing.JTextField useridField;
    private javax.swing.JLabel urlLab;
    // End of variables declaration//GEN-END:variables
    
}
