/*
 * ManyMap.java
 *
 * Created on April 15, 2003, 4:32 PM
 */

package dbmapper;

import java.io.Serializable;

/** This class encapsulates the info to define a Many to many mapping
 * (ie remote table, FK to home class and FK to remote class)
 *
 * @author Larry
 */
public class ManyMap implements Serializable, MappedReference {
    
    /** The remote table
     */    
    private String tableName;
    
    /** The FK to home class
     */    
    private String fkTome;
    
    /** The FK to the element class
     */    
    private String fkTooth;
    
    /** Is this info valid
     */    
    private boolean valid=false;
    
    /** The object we are mapped to
     */    
    private MappedReference obj = null;
    /** Hard define as MANY Manp type
     */    
    private final int mapType = ClassTableMap.MAP_TYPE_MANY;
    
    /** The properties of this mapping
     */    
    private MappingProperties mapProp = null;
    
    /** Creates a new instance of ManyMap */
    public ManyMap() {
    }
    
    /**
     * @return  */    
    public String getTablename(){ return tableName; }
    public void setTablename(String t){ tableName=t; }
    
    public String getFktome(){ return fkTome; }
    public void setFktome(String f){ fkTome=f; }
    
    public String getFktooth(){ return fkTooth; }
    public void setFktooth(String f){ fkTooth=f; }
    
    public boolean isValid(){return valid; }
    public void setValid(){ valid=true; }
    public void setValid(boolean flag){ valid=flag; }

    /** for MappedReference interface */
    public String getName(){ return tableName; }
    public String getType(){ return null; }
    public String getPPstr() { return "T:" + tableName + "{me:" + fkTome + "|oth:" +
                                 fkTooth + "}";}
    public int getMapType() { return mapType; }    
    public MappedReference getMappedTo(){ return obj; }
    public void setMappedTo(MappedReference o){ obj=o; }
    public boolean isMapped(){
        if ( obj != null ) return true;
        return false;
    }
    public void setMapType(int type){
        //ignore
    }
    
    public void setMappedTo(boolean flag) {
    }
    
    public MappingProperties getMapProp(){ return mapProp; }
    public void setMapProp(MappingProperties prop){ mapProp=prop; }
}
