/*
 * MappedReference.java
 *
 * Created on April 14, 2003, 11:53 AM
 */

package dbmapper;

/**
 * This is an interface for any object which can be mapped to another object.
 * It provides methods for getting it's name, type, a pretty print defintion
 * string, type of mapping, and properties of the mapping.
 *
 * This class is used at the attribute-column name level
 *
 * @author  Larry
 */
public interface MappedReference {
    
    public String getName();
    
    public String getType();
    
    public String getPPstr();
    
    public int getMapType();
    
    public MappedReference getMappedTo();
    public void setMappedTo(MappedReference o);
    public void setMapType(int type);
    
    public MappingProperties getMapProp();
    public void setMapProp(MappingProperties prop);
}
