/*
 * UserInputDialog.java
 *
 * Created on April 17, 2003, 4:29 PM
 */

package dbmapper;

/** Simple popup dialog form to receive input from the user
 * @author Larry
 */
public class UserInputDialog extends javax.swing.JDialog {
    
    /** The input text entered
     */    
    private String myInput = null;
    
    /** Retrun the input text entered by the user
     * @return message entered into form
     */    
    public String getInput(){ return myInput; }
    
    /** Creates new form UserInputDialog
     * @param parent parent frame
     * @param modal t/f/ modal flag
     */
    public UserInputDialog(java.awt.Frame parent, boolean modal) {
        this(parent, modal, "Enter text:");
    }
    
    /** Creates new form UserInputDialog w/text string to diplay before input area
     * @param parent parent frame
     * @param modal t/f/ modal flag
     * @param message message to display before user input field
     */    
    public UserInputDialog(java.awt.Frame parent, boolean modal, String message) {
        super(parent, modal);
        initComponents();
        messageText.setText(message);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        messageText = new javax.swing.JLabel();
        inputField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        okButt = new javax.swing.JButton();
        cancButt = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        messageText.setText("Message Display Text");
        getContentPane().add(messageText);

        getContentPane().add(inputField);

        okButt.setText("Ok");
        okButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtActionPerformed(evt);
            }
        });

        jPanel1.add(okButt);

        cancButt.setText("Cancel");
        cancButt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancButtActionPerformed(evt);
            }
        });

        jPanel1.add(cancButt);

        getContentPane().add(jPanel1);

        pack();
    }//GEN-END:initComponents

    /** "cancel" button callback. Clear out the text storage attribute and hide
     * this window.
     * @param evt callback event
     */    
    private void cancButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancButtActionPerformed
        // Add your handling code here:
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancButtActionPerformed

    /** "ok": button press callback. Save the text the user enetered into
     * the local myInput text attribute and hide this window
     * @param evt callback event
     */    
    private void okButtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtActionPerformed
        // Add your handling code here:
        myInput=inputField.getText();
        setVisible(false);
    }//GEN-LAST:event_okButtActionPerformed
    
    /** Closes the dialog
     * @param evt callback event
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField inputField;
    private javax.swing.JButton cancButt;
    private javax.swing.JButton okButt;
    private javax.swing.JLabel messageText;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
